#include<bits/stdc++.h>
using namespace std;
long long masiv[1000001];
long long indx[10000001];
int main(){
    long long N,K;
    cin>>N>>K;
    long long br1 = 0;
    long long br2 = 0;
    for(long long a=0;a<N;a++){
        cin>>masiv[a];
        if(br1<K){
           if(masiv[a]==1){
            br1++;
           }
        }
        if(br2<K){
           if(masiv[a]==2){
            indx[br2] = a;
            br2++;
           }
        }
    }
    if(br2>=K){
            long long br=1;
            for(long  long a=0;a<N;a++){
                    if(masiv[a]==1){
                             a=indx[br];
                        br++;
                    }

                if(a==indx[br]){
                    cout<<2;
                    break;
                }
                if(a==N-1)
                {
                    cout<<3;
                }
            }
    }
    else{
    if(br1>=K){
        cout<<1;
    }
    else{
        cout<<0;
    }
    }
return 0;
}
